-- 020-ImageAttributes.sql
-- ---------------------------------------
-- Author:  Ilya G. Goldberg (igg@nih.gov)
--           Douglas Creager (dcreager@alum.mit.edu)
-- Copyright 1999-2002 Open Microscopy Environment (OME)
-- This file is part of OME.
-- ---------------------------------------
-- 
--     OME is free software; you can redistribute it and/or modify
--     it under the terms of the GNU General Public License as published by
--     the Free Software Foundation; either version 2 of the License, or
--     (at your option) any later version.
-- 
--     OME is distributed in the hope that it will be useful,
--     but WITHOUT ANY WARRANTY; without even the implied warranty of
--     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--     GNU General Public License for more details.
-- 
--     You should have received a copy of the GNU General Public License
--     along with OME; if not, write to the Free Software
--     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- 


-- DC - March 4, 2003
-- Eventually _all_ of these tables will be replaced by XML descriptor
-- files.


--
-- One of these per image
-- CREATE TABLE IMAGE_DIMENSIONS (
--   ATTRIBUTE_ID    OID DEFAULT nextval('ATTRIBUTE_SEQ') PRIMARY KEY,
--   ANALYSIS_ID OID REFERENCES ANALYSES DEFERRABLE INITIALLY DEFERRED,
--   IMAGE_ID        OID NOT NULL REFERENCES IMAGES DEFERRABLE INITIALLY DEFERRED,
--   SIZE_X          INTEGER,    -- Number of X pixels, etc.
--   SIZE_Y          INTEGER,
--   SIZE_Z          INTEGER,
--   NUM_WAVES       INTEGER,
--   NUM_TIMES       INTEGER,
--   BITS_PER_PIXEL  SMALLINT,
--   PIXEL_SIZE_X    FLOAT4,     -- These are in microns per pixel.
--   PIXEL_SIZE_Y    FLOAT4,
--   PIXEL_SIZE_Z    FLOAT4,
--   WAVE_INCREMENT  FLOAT4,     -- This is in nm.
--   TIME_INCREMENT  FLOAT4      -- This is in seconds.
-- );
-- CREATE INDEX IMAGE_DIMENSIONS_ID_idx ON IMAGE_DIMENSIONS (IMAGE_ID);
-- COMMENT ON TABLE IMAGE_DIMENSIONS IS
-- 'This table describes the extents of each dimension of a 5-D image - \
-- both in number of pixels and in the physical size of the pixels in \
-- microns.';
-- COMMENT ON COLUMN IMAGE_DIMENSIONS.WAVE_INCREMENT IS
-- 'This column is used when the wave dimension is contiguous rather than \
-- discrete (e.g. FTIR imaging).  This value is the number of nm \
-- (nano-meters) between wavelengths.';
-- COMMENT ON COLUMN IMAGE_DIMENSIONS.TIME_INCREMENT IS
-- 'This column is used when the time dimension is contiguous rather than \
-- discrete (e.g. a video stream).  This value is the number of seconds \
-- between timepoints.';

-- INSERT INTO DATA_TABLES VALUES 
-- (NEXTVAL('DATA_TABLE_SEQ'),'I','IMAGE_DIMENSIONS','General image attributes');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'SIZE_X',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'SIZE_Y',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'SIZE_Z',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'NUM_WAVES',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'NUM_TIMES',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'BITS_PER_PIXEL',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'PIXEL_SIZE_X',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'PIXEL_SIZE_Y',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'PIXEL_SIZE_Z',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'WAVE_INCREMENT',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'TIME_INCREMENT',NULL,'');


--
-- One of these per XYZ raster (one per time point per wavelength per image)
-- CREATE TABLE XYZ_IMAGE_INFO (
--         ATTRIBUTE_ID    OID DEFAULT nextval('ATTRIBUTE_SEQ') PRIMARY KEY,
--         ANALYSIS_ID OID REFERENCES ANALYSES DEFERRABLE INITIALLY DEFERRED,
--         IMAGE_ID        OID NOT NULL REFERENCES IMAGES DEFERRABLE INITIALLY DEFERRED,
--         WAVENUMBER      INTEGER,    -- This is the order of the wavelengths in the image.
--         TIMEPOINT       INTEGER,    -- This is a timepoint #
--         DELTATIME       FLOAT,      -- This is time in seconds relative to the first XYZ.
--                                                                 -- More precisely, this is the deltatime of the first Z section in the stack
--         MIN             INTEGER,
--         MAX             INTEGER,
--         MEAN            FLOAT4,
--         GEOMEAN         FLOAT4,
--         SIGMA           FLOAT4,
--         CENTROID_X      FLOAT4,     -- These are the "center of mass" for the XYZ stack.
--         CENTROID_Y      FLOAT4,
--         CENTROID_Z      FLOAT4
-- );
-- CREATE INDEX XYZ_INFO_ID_idx ON XYZ_IMAGE_INFO (IMAGE_ID);
-- COMMENT ON TABLE XYZ_IMAGE_INFO IS
-- 'This table contains statistics and timing information for each XYZ stack in a 5-D image.';
-- COMMENT ON COLUMN XYZ_IMAGE_INFO.DELTATIME IS
-- 'Time in seconds since acquisition began.';
-- COMMENT ON COLUMN XYZ_IMAGE_INFO.CENTROID_X IS
-- 'Center of mass of the XYZ stack.';
-- COMMENT ON COLUMN XYZ_IMAGE_INFO.CENTROID_Y IS
-- 'Center of mass of the XYZ stack.';
-- COMMENT ON COLUMN XYZ_IMAGE_INFO.CENTROID_Z IS
-- 'Center of mass of the XYZ stack.';

-- INSERT INTO DATA_TABLES VALUES 
-- (NEXTVAL('DATA_TABLE_SEQ'),'I','XYZ_IMAGE_INFO','General image XYZ stack attributes');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'WAVENUMBER',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'TIMEPOINT',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'DELTATIME',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'MIN',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'MAX',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'MEAN',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'GEOMEAN',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'SIGMA',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'CENTROID_X',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'CENTROID_Y',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'CENTROID_Z',NULL,'');



-- One of these per XY-plane in an XYZWT stack.
-- CREATE TABLE XY_IMAGE_INFO (
--         ATTRIBUTE_ID    OID DEFAULT NEXTVAL('ATTRIBUTE_SEQ') PRIMARY KEY,
--         ANALYSIS_ID OID REFERENCES ANALYSES DEFERRABLE INITIALLY DEFERRED,
--         IMAGE_ID        OID NOT NULL REFERENCES IMAGES DEFERRABLE INITIALLY DEFERRED,
--         WAVENUMBER      INTEGER,    -- This is the order of the wavelengths in the image.
--         TIMEPOINT       INTEGER,    -- This is a timepoint #
--         ZSECTION        INTEGER,    -- The Z section number for these stats
--         DELTATIME       FLOAT,      -- This is time in seconds relative to the first plane acquired for this image.
--         EXPTIME         FLOAT,      -- The exposure time in seconds
--         STAGE_X         FLOAT,      -- Stage coordinates in microscope's reference frame.  FIXME:  units???.
--         STAGE_Y         FLOAT,      -- only meaningful relative to each other or with knowledge of what the microscope frame is.
--         STAGE_Z         FLOAT,
--         MIN             INTEGER,
--         MAX             INTEGER,
--         MEAN            FLOAT4,
--         GEOMEAN         FLOAT4,
--         SIGMA           FLOAT4,
--         CENTROID_X      FLOAT4,
--         CENTROID_Y      FLOAT4
-- );
-- CREATE INDEX XY_INFO_ID_idx ON XY_IMAGE_INFO (IMAGE_ID);

-- COMMENT ON TABLE XY_IMAGE_INFO IS
-- 'This table stores statistics, timing and stage position information for each XY plane in a 5-D image';

-- INSERT INTO DATA_TABLES VALUES 
-- (NEXTVAL('DATA_TABLE_SEQ'),'I','XY_IMAGE_INFO','General image XY slice attributes');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'WAVENUMBER',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'TIMEPOINT',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'ZSECTION',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'DELTATIME',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'EXPTIME',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'STAGE_X',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'STAGE_Y',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'STAGE_Z',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'MIN',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'MAX',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'MEAN',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'GEOMEAN',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'SIGMA',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'CENTROID_X',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'CENTROID_Y',NULL,'');

--
-- One of these per wavelength in the image.
-- CREATE TABLE IMAGE_WAVELENGTHS (
--   ATTRIBUTE_ID    OID DEFAULT NEXTVAL('ATTRIBUTE_SEQ') PRIMARY KEY,
--   ANALYSIS_ID OID REFERENCES ANALYSES DEFERRABLE INITIALLY DEFERRED,
--   IMAGE_ID        OID REFERENCES IMAGES DEFERRABLE INITIALLY DEFERRED,
--   WAVENUMBER      INTEGER,    -- This is the order of the wavelengths in the image.
--   EX_WAVELENGTH   INTEGER,    -- This is in nm.
--   EM_WAVELENGTH   INTEGER,    -- This is in nm.
--   ND_FILTER       FLOAT,      -- This is a percentage between 0.0 and 1.0.
--   FLUOR           VARCHAR(32) -- This is the fluorescent compound (i.e. GFP,FITC, TR, etc.  Not GFP-NFAT or TR-goat-anti-rabbit).
-- );
-- CREATE INDEX IMAGE_WAVELENGTHS_ID_idx ON IMAGE_WAVELENGTHS (IMAGE_ID);

-- COMMENT ON TABLE IMAGE_WAVELENGTHS IS
-- 'This table stores information about each wavelength in a 5-D image.';
-- COMMENT ON COLUMN IMAGE_WAVELENGTHS.WAVENUMBER IS
-- 'The order of the wave as it stored in the 5-D image - starting at \
-- zero.';
-- COMMENT ON COLUMN IMAGE_WAVELENGTHS.EX_WAVELENGTH IS
-- 'In nm.';
-- COMMENT ON COLUMN IMAGE_WAVELENGTHS.EM_WAVELENGTH IS
-- 'In nm.';
-- COMMENT ON COLUMN IMAGE_WAVELENGTHS.ND_FILTER IS
-- 'A percentage between 0.0 and 1.0.  A value of 1.0 does not transmit \
-- visible light.';
-- COMMENT ON COLUMN IMAGE_WAVELENGTHS.FLUOR IS
-- 'The fluorescent compound - i.e. GFP, eGFP, DAPI, FITC, etc., not \
-- GFP-p53 or FITC-goat-anti-rabbit';

-- INSERT INTO DATA_TABLES VALUES 
-- (NEXTVAL('DATA_TABLE_SEQ'),'I','IMAGE_WAVELENGTHS',
-- 'General image wavelength attributes');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'WAVENUMBER',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
        -- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'EX_WAVELENGTH',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'EM_WAVELENGTH',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'ND_FILTER',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'FLUOR',NULL,'');


-- --
-- -- This table contains SoftWorx-specific data for each XY plane.
-- CREATE TABLE XY_SOFTWORX_INFO (
--   ATTRIBUTE_ID         OID DEFAULT NEXTVAL('ATTRIBUTE_ID') PRIMARY KEY,
--   ANALYSIS_ID OID REFERENCES ANALYSES DEFERRABLE INITIALLY DEFERRED,
--   IMAGE_ID             OID      REFERENCES IMAGES DEFERRABLE INITIALLY DEFERRED,
--   WAVENUMBER           INTEGER,    -- This is the order of the wavelengths in the image.
--   TIMEPOINT            INTEGER,    -- This is a timepoint #
--   ZSECTION             INTEGER,    -- The Z section number for these stats
--   PHOTOSENSOR_READING  FLOAT,
--   INTEN_SCALING        FLOAT
-- );
-- CREATE INDEX XY_softworx_info_ID_idx ON XY_softworx_info (IMAGE_ID);
-- COMMENT ON TABLE XY_SOFTWORX_INFO IS
-- 'This table stores SoftWorx (API) specific information about each \
-- plane in the 5-D image';

-- INSERT INTO DATA_TABLES VALUES 
-- (NEXTVAL('DATA_TABLE_SEQ'),'I','XY_SOFTWORX_INFO','Softworx-specific image attributes');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'WAVENUMBER',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'TIMEPOINT',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'ZSECTION',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'PHOTOSENSOR_READING',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'INTEN_SCALING',NULL,'');

--
-- CREATE SEQUENCE SCREEN_SEQ;
-- CREATE TABLE SCREENS (
--   SCREEN_ID        OID    DEFAULT nextval ('SCREEN_SEQ') PRIMARY KEY,
--   NAME             VARCHAR(255),
--   DESCRIPTION      TEXT,
--   EXTERN_SCREEN_ID varchar(40)  --  This refers to the site's screen/plate database.
-- );

-- COMMENT ON TABLE SCREENS IS
-- 'This table stores information about a high-throughput screen';
-- COMMENT ON COLUMN SCREENS.EXTERN_SCREEN_ID IS
-- 'A reference to an external database containing screen information';

-- --
-- CREATE SEQUENCE PLATE_SEQ;
-- CREATE TABLE PLATES (
--   PLATE_ID        OID    DEFAULT nextval ('PLATE_SEQ') PRIMARY KEY,
--   NAME            VARCHAR(255),
--   EXTERN_PLATE_ID varchar(40)   --  This refers to the site's screen/plate database.
-- );

-- COMMENT ON TABLE PLATES IS
-- 'This table stores information about the plates that make up a \
-- high-throughput screen.  Plates may belong to more than one screen, \
-- and have a many-to-many relationship to screens.';
-- COMMENT ON COLUMN PLATES.EXTERN_PLATE_ID IS
-- 'A reference to an external database containing plate information';

-- --  Establishes a many-to-many relationship between plates and screens
-- --  This means plates can be re-cycled for different screens.
-- CREATE TABLE SCREEN_PLATE_MAP (
--   SCREEN_ID       OID    REFERENCES SCREENS DEFERRABLE INITIALLY DEFERRED,
--   PLATE_ID        OID    REFERENCES PLATES DEFERRABLE INITIALLY DEFERRED,
--   PRIMARY KEY (SCREEN_ID, PLATE_ID)
-- );

-- COMMENT ON TABLE SCREEN_PLATE_MAP IS
-- 'This table specifies the many-to-many relationshiop between screens \
-- and plates.';


-- --
-- --  One of these per image that is part of a 'screen'.
-- CREATE TABLE IMAGE_SCREEN_INFO (
--   ATTRIBUTE_ID      OID DEFAULT NEXTVAL('ATTRIBUTE_SEQ') PRIMARY KEY,
--   ANALYSIS_ID OID REFERENCES ANALYSES DEFERRABLE INITIALLY DEFERRED,
--   IMAGE_ID          OID REFERENCES IMAGES DEFERRABLE INITIALLY DEFERRED,
--   PLATE_ID          OID REFERENCES PLATES DEFERRABLE INITIALLY DEFERRED,
--   WELL              VARCHAR(8),
--   SAMPLE            INTEGER,    -- This is the sample number within a well.
--   EXTERN_SAMPLE_ID  varchar(40) --  This refers to the site's screen/plate database (usually what's in the well).
-- );
-- CREATE INDEX IMAGE_SCREEN_INFO_IMAGE ON IMAGE_SCREEN_INFO(IMAGE_ID);
-- CREATE INDEX IMAGE_SCREEN_INFO_PLATE ON IMAGE_SCREEN_INFO(PLATE_ID);

-- COMMENT ON TABLE IMAGE_SCREEN_INFO IS
-- 'This table stores additional information for images that are part of \
-- a high-throughput screen.';
-- COMMENT ON COLUMN IMAGE_SCREEN_INFO.WELL IS
-- 'The well address (e.g. A12) on a microtiter plate.';
-- COMMENT ON COLUMN IMAGE_SCREEN_INFO.SAMPLE IS
-- 'The sample number within a well on a microtiter plate.';
-- COMMENT ON COLUMN IMAGE_SCREEN_INFO.EXTERN_SAMPLE_ID IS
-- 'A link to an external database with additional information about this \
-- sample (image).';

-- INSERT INTO DATA_TABLES VALUES 
-- (NEXTVAL('DATA_TABLE_SEQ'),'I','IMAGE_SCREEN_INFO','Screen-based image attributes');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'PLATE_ID',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'WELL',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'SAMPLE',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'EXTERN_SAMPLE_ID',NULL,'');


-- --
-- --  One of these per image to contain a 'stage' label.
-- CREATE TABLE IMAGE_STAGE_INFO (
--   ATTRIBUTE_ID    OID  DEFAULT NEXTVAL('ATTRIBUTE_SEQ') PRIMARY KEY,
--   ANALYSIS_ID OID REFERENCES ANALYSES DEFERRABLE INITIALLY DEFERRED,
--   IMAGE_ID        OID     REFERENCES IMAGES DEFERRABLE INITIALLY DEFERRED,
--   LABEL           TEXT,     -- A text 'label' for this stage position.
--   STAGE_X         FLOAT,      -- Stage coordinates in microscope's reference frame.  FIXME:  units???.
--   STAGE_Y         FLOAT,      -- Since there is only one of these per image, the convention is that this is the
--   STAGE_Z         FLOAT       -- average stage position for the entire image.
-- );                          -- Stage positions for individual planes are store in xy_image_info.
-- CREATE INDEX IMAGE_STAGE_INFO_IMAGE ON IMAGE_STAGE_INFO(IMAGE_ID);

-- COMMENT ON TABLE IMAGE_STAGE_INFO IS
-- 'This table stores stage position and label information about an image.';

-- INSERT INTO DATA_TABLES VALUES 
-- (NEXTVAL('DATA_TABLE_SEQ'),'I','IMAGE_STAGE_INFO','Stage-based image attributes');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'LABEL',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'STAGE_X',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'STAGE_Y',NULL,'');
-- INSERT INTO DATA_COLUMNS VALUES
-- (NEXTVAL('DATA_COLUMN_SEQ'),CURRVAL('DATA_TABLE_SEQ'),'STAGE_Z',NULL,'');

--
-- siah added 3/19/03
-- This table stores viewer settings for an image. 

--CREATE TABLE DISPLAY_SETTINGS (
--ATTRIBUTE_ID      OID DEFAULT NEXTVAL ('ATTRIBUTE_SEQ') PRIMARY KEY,
--   IMAGE_ID          OID NOT NULL REFERENCES IMAGES DEFERRABLE INITIALLY DEFERRED, 
--   RED_WAVENUM       INTEGER, 
--   RED_BLACK_LEVEL   DOUBLE PRECISION, 
--   RED_SCALE         DOUBLE PRECISION, 
--   DISPLAY_RED       BOOLEAN,
--   BLUE_WAVENUM      INTEGER,
--   BLUE_BLACK_LEVEL  DOUBLE PRECISION, 
--   BLUE_SCALE        DOUBLE PRECISION, 
--   DISPLAY_BLUE      BOOLEAN,
--   GREEN_WAVENUM     INTEGER, 
--   GREEN_BLACK_LEVEL DOUBLE PRECISION, 
--   GREEN_SCALE       DOUBLE PRECISION, 
--   DISPLAY_GREEN     BOOLEAN,
--   GREY_WAVENUM      INTEGER, 
--   GREY_BLACK_LEVEL  DOUBLE PRECISION, 
--   GREY_SCALE        DOUBLE PRECISION, 
--   THE_Z             INTEGER, 
--   THE_T             INTEGER,
--   IS_RGB            BOOLEAN
--);
-- COMMENT ON TABLE DISPLAY_SETTINGS IS
-- 'This table stores viewer settings for an image.';
