-- Author:  Ilya G. Goldberg (igg@mit.edu)
-- Copyright 1999-2001 Ilya G. Goldberg
-- This file is part of OME.
-- 
--     OME is free software; you can redistribute it and/or modify
--     it under the terms of the GNU General Public License as published by
--     the Free Software Foundation; either version 2 of the License, or
--     (at your option) any later version.
-- 
--     OME is distributed in the hope that it will be useful,
--     but WITHOUT ANY WARRANTY; without even the implied warranty of
--     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--     GNU General Public License for more details.
-- 
--     You should have received a copy of the GNU General Public License
--     along with OME; if not, write to the Free Software
--     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- 
--
CREATE TABLE CCCP (
ATTRIBUTE_OF        OID,
ANALYSIS_ID         OID        REFERENCES ANALYSES (ANALYSIS_ID) DEFERRABLE INITIALLY DEFERRED,
correlation         FLOAT,
correlation_masked  FLOAT,
spearman            FLOAT,
spearman_masked     FLOAT
);
CREATE INDEX CCCP_ATTRIBUTE_OF_idx ON CCCP (ATTRIBUTE_OF);
CREATE INDEX CCCP_ANALYSIS_ID_idx  ON CCCP (ANALYSIS_ID);
--
CREATE TABLE INPUT_CCCP (
ANALYSIS_ID    OID    REFERENCES ANALYSES DEFERRABLE INITIALLY DEFERRED,
NUM_WAVES      INTEGER,
DATASET_ID_W1  OID,
DATASET_ID_W2  OID,
DATASET_ID_W3  OID
);
--
INSERT INTO PROGRAMS (PROGRAM_ID,PROGRAM_NAME,LOCATION,DESCRIPTION,CATEGORY,INPUT_TABLE) VALUES (
nextval ('PROGRAM_SEQ'),
'CCCP',
'/OME/bin/ome_cccp',
'Calculates a Correlation Coefficient between two wavelengths.',
'Correlation',
'INPUT_CCCP'
);
--
INSERT INTO ATTRIBUTE_LIST (PROGRAM_ID,TABLE_NAME) VALUES (currval('PROGRAM_SEQ'),'CCCP');
--
--
--
CREATE TABLE TMCP (
ATTRIBUTE_OF        OID,
ANALYSIS_ID         OID        REFERENCES ANALYSES (ANALYSIS_ID) DEFERRABLE INITIALLY DEFERRED,
TMCP         FLOAT
);
CREATE INDEX TMCP_ATTRIBUTE_OF_idx ON TMCP (ATTRIBUTE_OF);
CREATE INDEX TMCP_ANALYSIS_ID_idx  ON TMCP (ANALYSIS_ID);
--
CREATE TABLE INPUT_TMCP (
ANALYSIS_ID    OID    REFERENCES ANALYSES DEFERRABLE INITIALLY DEFERRED,
REF_WAVE       OID,
TRACK_WAVE     OID,
CUTOFF         INTEGER,
FLAG           varchar(10)
);
--
INSERT INTO PROGRAMS (PROGRAM_ID,PROGRAM_NAME,LOCATION,DESCRIPTION,CATEGORY,INPUT_TABLE) VALUES (
nextval ('PROGRAM_SEQ'),
'TMCP',
'/OME/bin/ome_tmcp',
'Tracking Movements of Cellular Position - For each pixel in the tracked wavelength, calculates distance to nearest pixel in the reference (mask or binary) image, and multiplies the distance by the pixel value in the tracked wavelength',
'ICCB',
'INPUT_TMCP'
);
--
INSERT INTO ATTRIBUTE_LIST (PROGRAM_ID,TABLE_NAME) VALUES (currval('PROGRAM_SEQ'),'TMCP');
