-- Author:  Ilya G. Goldberg (igg@mit.edu)
-- Copyright 1999-2001 Ilya G. Goldberg
-- This file is part of OME.
-- 
--     OME is free software; you can redistribute it and/or modify
--     it under the terms of the GNU General Public License as published by
--     the Free Software Foundation; either version 2 of the License, or
--     (at your option) any later version.
-- 
--     OME is distributed in the hope that it will be useful,
--     but WITHOUT ANY WARRANTY; without even the implied warranty of
--     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--     GNU General Public License for more details.
-- 
--     You should have received a copy of the GNU General Public License
--     along with OME; if not, write to the Free Software
--     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-- 
--

CREATE TABLE NEURITE (
ATTRIBUTE_OF        OID,
ANALYSIS_ID         OID        REFERENCES ANALYSES (ANALYSIS_ID) DEFERRABLE INITIALLY DEFERRED,
ratio             FLOAT
);
CREATE INDEX NEURITE_ATTRIBUTE_OF_idx ON NEURITE (ATTRIBUTE_OF);
CREATE INDEX NEURITE_ANALYSIS_ID_idx  ON NEURITE (ANALYSIS_ID);
--
CREATE TABLE INPUT_NEURITE (
ANALYSIS_ID    OID    REFERENCES ANALYSES DEFERRABLE INITIALLY DEFERRED,
NEURITE_ID     OID,
NUCLEI_ID      OID,
TEMPLATE_DISK  INTEGER,
PEAK_THRESH    FLOAT,
DIAL_RADIUS    INTEGER,
CLOSE_DISK     INTEGER,
WIENER_FILT    FLOAT
);

INSERT INTO PROGRAMS (PROGRAM_ID,PROGRAM_NAME,DESCRIPTION,CATEGORY,INPUT_TABLE) VALUES (
nextval ('PROGRAM_SEQ'),
'Neurite',
'Specialized matlab program to score neurons',
'ICCB',
'INPUT_NEURITE'
);

INSERT INTO ATTRIBUTE_LIST (PROGRAM_ID,TABLE_NAME) VALUES (currval('PROGRAM_SEQ'),'NEURITE');
