--------------------------------------------------------------------------------
-- oid-fix.sql
-- Douglas Creager <dcreager@alum.mit.edu>
-- 20 February 2002
--------------------------------------------------------------------------------
-- Fixes a problem in PostgreSQL 7.2 where the OID type is no longer type-
-- compatible with sequences, preventing their use as primary keys.
--------------------------------------------------------------------------------

CREATE FUNCTION OID(INT8) RETURNS OID AS '
declare
  i8 alias for $1;
begin
  return int4(i8);
end;'
LANGUAGE 'plpgsql';
