/*
 * org.openmicroscopy.ChainExecution
 *
 * Copyright (C) 2002 Open Microscopy Environment, MIT
 * Author:  Douglas Creager <dcreager@alum.mit.edu>
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation; either
 *    version 2.1 of the License, or (at your option) any later version.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package org.openmicroscopy;

import java.util.List;
import java.util.Iterator;

public interface ChainExecution
    extends OMEObject
{
    public String getTimestamp();
    public void setTimestamp(String timestamp);

    public Chain getChain();
    public void setChain(Chain chain);

    public Dataset getDataset();
    public void setDataset(Dataset dataset);

    public Attribute getExperimenter();
    public void setExperimenter(Attribute experimenter);

    public List getNodes();
    public Iterator iterateNodes();

    public interface Node
        extends OMEObject
    {
        public ChainExecution getChainExecution();

        public Chain.Node getChainNode();
        public void setChainNode(Chain.Node node);

        public ModuleExecution getModuleExecution();
        public void setModuleExecution(ModuleExecution analysis);
    }
}
