# OME/module_execution/FindRatio.pm

# Copyright (C) 2002 Open Microscopy Environment, MIT
# Author:  Douglas Creager <dcreager@alum.mit.edu>
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package OME::Analysis::FindRatio;

use OME::Analysis::Handler;

use strict;
our $VERSION = 2.000_000;

use base qw(OME::Analysis::Handler);


sub calculateFeature {
    my ($self) = @_;

    my $numerator_features = $self->getFeatureInputs('Golgi bounds');
    my $denominator_features = $self->getFeatureInputs('Mito bounds');

    my $numerator = scalar(@$numerator_features);
    my $denominator = scalar(@$denominator_features);

    no integer;
    my $ratio = ($denominator == 0)? 0: $numerator/$denominator;
    use integer;

    my $ratio_attribute = $self->
      newAttributes("Golgi-mito ratio",
                    {
                     Ratio => $ratio
                    });
}

1;
