# OME/Web/InfoProject.pm

# Copyright (C) 2002 Open Microscopy Environment, MIT
# Author:  Jean-Marie Burel <j.burel@dundee.ac.uk>
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


package OME::Web::InfoProject;

use strict;
use vars qw($VERSION);
$VERSION = 2.000_000;
use CGI;
use OME::Tasks::ProjectManager;
use OME::Web::Helper::HTMLFormat;
use OME::Web::Helper::JScriptFormat;

use base qw(OME::Web);


sub getPageTitle {
	return "Open Microscopy Environment" ;
}

sub getPageBody{
  my $self=shift;
  my $cgi=$self->CGI();
  my $body="";
  my $session=$self->Session(); 
  my $projectManager=new OME::Tasks::ProjectManager($session); 
  my $htmlFormat=new OME::Web::Helper::HTMLFormat;
  my $jscriptFormat=new OME::Web::Helper::JScriptFormat;



  my $usergpID=$cgi->url_param('UsergpID');
  
 	
  if ( !defined $usergpID){
    die "Package needs UsergpID as url parameters. Neither was supplied. This message generated by ".(ref $self)."->createOMEPage().";	
  }
  if (defined $usergpID){
    $body.=$jscriptFormat->popUpDataset();
    my $projects=$projectManager->listMatching($usergpID);
    if (scalar(@$projects)>0){
   	 $body.="<h3>Description</h3>";
    	 foreach (@$projects){
	   $body.=$htmlFormat->formatProject($_,1);
       }
    }else{
	$body.="<h3>No existing project</h3>";

    }
  }
  $body.="<br><br>";
  $body.=$jscriptFormat->closeButton();    
  return('HTML',$body);




}


1;

