# OME/Web/TitleBar.pm

# Copyright (C) 2002 Open Microscopy Environment, MIT
# Author:  Douglas Creager <dcreager@alum.mit.edu>
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# JM 07-03-03 remove viewer in TitleBar

package OME::Web::TitleBar;

use strict;
use vars qw($VERSION);
$VERSION = 2.000_000;

use OME::DBObject;
use OME::Web::Helper::HTMLFormat;

use base qw{ OME::Web };

sub getPageTitle {
	return "Open Microscopy Environment - Title Bar";
}

sub getPageBody {
	my $self = shift;
	my $body = "";
	my $session = $self->Session();
	my $experimenter = $self->User()
		or die "User not defined for this session";

	my $htmlFormat=new OME::Web::Helper::HTMLFormat;
	$body.=$htmlFormat->titleBar($experimenter,$session->project(),$session->dataset());
	return ('HTML',$body);
}



1;
